//////////////////////////////////////////////////////
////Addon			: Bounded Drag & Drop
////Type			: Behavior
////Version 		: 2.0.0.0
////Author			: Chadori_RebornXD
////Description		: An advanced version of Drag and drop. Drags & Drops objects either by mouse or touch with bounds.
////Dependency 		: None
////Distribution 	: Free
////Compatibility	: Construct 3 & Construct 2
////Help			: https://www.construct.net/make-games/addons/91/bounded-drag-drop
////Comment			: In case you need help, Google it.
//////////////////////////////////////////////////////

//Converted with C2C3AddonConverter v1.0.0.15
"use strict";

{
	const BEHAVIOR_ID = "CV_BoundedDragnDrop";
	const BEHAVIOR_VERSION = "1.0.0.0";
	const BEHAVIOR_CATEGORY = "other";
	const BEHAVIOR_CLASS = SDK.Behaviors.CV_BoundedDragnDrop = class CV_BoundedDragnDrop extends SDK.IBehaviorBase
	{
		constructor()
		{
			super(BEHAVIOR_ID);
			SDK.Lang.PushContext("behaviors." + BEHAVIOR_ID.toLowerCase());
			this._info.SetIcon("icon.png", "image/png");
			this._info.SetName(lang(".name"));
			this._info.SetDescription(lang(".description"));
			this._info.SetVersion(BEHAVIOR_VERSION);
			this._info.SetCategory(BEHAVIOR_CATEGORY);
			this._info.SetAuthor("Chadori_RebornXD & Scirra");
			this._info.SetHelpUrl(lang(".help-url"));
			this._info.SetIsOnlyOneAllowed(false);

			// Support both the C2 and C3 runtimes
			this._info.SetSupportedRuntimes(["c2", "c3"]);

			SDK.Lang.PushContext(".properties");
			this._info.SetProperties([
				new SDK.PluginProperty("combo", "axes", {initialValue:"both", items:["both","horizontal only","vertical only"]}),
				new SDK.PluginProperty("combo", "initial-state", {initialValue:"enabled", items:["disabled","enabled"]}),
				new SDK.PluginProperty("combo", "bound-to", {initialValue:"radius", items:["off","both","radius","position"]}),
				new SDK.PluginProperty("combo", "bound-by", {initialValue:"origin", items:["origin","edge"]}),
				new SDK.PluginProperty("combo", "bound-method", {initialValue:"clamp", items:["halt","clamp"]}),
				new SDK.PluginProperty("integer", "bound-xradius", 100),
				new SDK.PluginProperty("integer", "bound-yradius", 100),
				new SDK.PluginProperty("integer", "bound-min-x", 0),
				new SDK.PluginProperty("integer", "bound-max-x", 0),
				new SDK.PluginProperty("integer", "bound-min-y", 0),
				new SDK.PluginProperty("integer", "bound-max-y", 0)
			]);
			SDK.Lang.PopContext();		// .properties
			SDK.Lang.PopContext();
		}
	};
	BEHAVIOR_CLASS.Register(BEHAVIOR_ID, BEHAVIOR_CLASS);
}
