//////////////////////////////////////////////////////
////Addon			: Bounded Drag & Drop
////Type			: Behavior
////Version 		: 2.0.0.0
////Author			: Chadori_RebornXD
////Description		: An advanced version of Drag and drop. Drags & Drops objects either by mouse or touch with bounds.
////Dependency 		: None
////Distribution 	: Free
////Compatibility	: Construct 3 & Construct 2
////Help			: https://www.construct.net/make-games/addons/91/bounded-drag-drop
////Comment			: In case you need help, Google it.
//////////////////////////////////////////////////////

"use strict";

{
	C3.Behaviors.CV_BoundedDragnDrop = class BoundedDragnDrop extends C3.SDKBehaviorBase
	{
		constructor(opts)
		{
			super(opts);
			const b = this._runtime.Dispatcher();
			this._disposables = new C3.CompositeDisposable(C3.Disposable.From(b, "pointerdown", (a) => this._OnPointerDown(a.data)), C3.Disposable.From(b, "pointermove", (a) => this._OnPointerMove(a.data)), C3.Disposable.From(b, "pointerup", (a) => this._OnPointerUp(a.data, !1)), C3.Disposable.From(b, "pointercancel", (a) => this._OnPointerUp(a.data, !0)), C3.Disposable.From(b, "mousemove", (a) => this._OnMouseMove(a.data)), C3.Disposable.From(b, "mousedown", (a) => this._OnMouseDown(a.data)), C3.Disposable.From(b, "mouseup", (a) => this._OnMouseUp(a.data)))
		}
		
		Release()
		{
			super.Release();
		}

		//-- Custom Class Functions :: Start

		Release() {
			this._disposables.Release(), this._disposables = null, super.Release()
		}
	
		_OnPointerDown(a) {
			"mouse" === a.pointerType || this._OnInputDown(a.pointerId.toString(), a.clientX - this._runtime.GetCanvasClientX(), a.clientY - this._runtime.GetCanvasClientY())
		}
	
		_OnPointerMove(a) {
			"mouse" === a.pointerType || this._OnInputMove(a.pointerId.toString(), a.clientX - this._runtime.GetCanvasClientX(), a.clientY - this._runtime.GetCanvasClientY())
		}
	
		_OnPointerUp(a) {
			"mouse" === a.pointerType || this._OnInputUp(a.pointerId.toString())
		}
	
		_OnMouseDown(a) {
			0 !== a.button || this._OnInputDown("mouse", a.clientX - this._runtime.GetCanvasClientX(), a.clientY - this._runtime.GetCanvasClientY())
		}
	
		_OnMouseMove(a) {
			0 !== a.button || this._OnInputMove("mouse", a.clientX - this._runtime.GetCanvasClientX(), a.clientY - this._runtime.GetCanvasClientY())
		}
	
		_OnMouseUp(a) {
			0 !== a.button || this._OnInputUp("mouse")
		}
	
		_OnInputDown(a, b, c) {
			const d = this.GetInstances();
			let e = null,
				f = null,
				g = 0,
				h = 0;
			for (const i of d) {
				const a = i.GetBehaviorSdkInstanceFromCtor(C3.Behaviors.CV_BoundedDragnDrop);
				if (!a.IsEnabled() || a.IsDragging()) continue;
				const d = i.GetWorldInfo(),
					j = d.GetLayer(),
					[k, l] = j.CanvasCssToLayer(b, c);
				if (!d.ContainsPoint(k, l)) continue;
				if (!e) {
					e = i, f = a, g = k, h = l;
					continue
				}
				const m = e.GetWorldInfo();
				(j.GetIndex() > m.GetLayer().GetIndex() || j.GetIndex() === m.GetLayer().GetIndex() && d.GetZIndex() > m.GetZIndex()) && (e = i, f = a, g = k, h = l)
			}
			e && f._OnDown(a, g, h)
		}
	
		_OnInputMove(a, b, c) {
			const d = this.GetInstances();
			for (const e of d) {
				const d = e.GetBehaviorSdkInstanceFromCtor(C3.Behaviors.CV_BoundedDragnDrop);
				if (!d.IsEnabled() || !d.IsDragging() || d.IsDragging() && d.GetDragSource() !== a) continue;
				const f = e.GetWorldInfo().GetLayer(),
					[g, h] = f.CanvasCssToLayer(b, c);
				d._OnMove(g, h)
			}
		}
	
		_OnInputUp(a) {
			const b = this.GetInstances();
			for (const c of b) {
				const b = c.GetBehaviorSdkInstanceFromCtor(C3.Behaviors.CV_BoundedDragnDrop);
				b.IsDragging() && b.GetDragSource() === a && b._OnUp()
			}
		}	

		//-- Custom Class Functions :: End

	};
}